---
title: CanvasRenderingContext2D.bezierCurveTo()
slug: Web/API/CanvasRenderingContext2D/bezierCurveTo
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.bezierCurveTo()</code></strong> method of the Canvas 2D API adds a cubic <a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve">Bézier curve</a> to the current sub-path. It requires three points: the first two are control points and the third one is the end point. The starting point is the latest point in the current path, which can be changed using {{domxref("CanvasRenderingContext2D.moveTo", "moveTo()")}} before creating the Bézier curve.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.bezierCurveTo(<em>cp1x</em>, <em>cp1y</em>, <em>cp2x</em>, <em>cp2y</em>, <em>x</em>, <em>y</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>cp1x</code></dt>
 <dd>The x-axis coordinate of the first control point.</dd>
 <dt><code>cp1y</code></dt>
 <dd>The y-axis coordinate of the first control point.</dd>
 <dt><code>cp2x</code></dt>
 <dd>The x-axis coordinate of the second control point.</dd>
 <dt><code>cp2y</code></dt>
 <dd>The y-axis coordinate of the second control point.</dd>
 <dt><code>x</code></dt>
 <dd>The x-axis coordinate of the end point.</dd>
 <dt><code>y</code></dt>
 <dd>The y-axis coordinate of the end point.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="How_bezierCurveTo_works">How bezierCurveTo works</h3>

<p>This example shows how a cubic Bézier curve is drawn.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[14]">// Define canvas and context
const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Define the points as {x, y}
let start = { x: 50,    y: 20  };
let cp1 =   { x: 230,   y: 30  };
let cp2 =   { x: 150,   y: 80  };
let end =   { x: 250,   y: 100 };

// Cubic Bézier curve
ctx.beginPath();
ctx.moveTo(start.x, start.y);
ctx.bezierCurveTo(cp1.x, cp1.y, cp2.x, cp2.y, end.x, end.y);
ctx.stroke();

// Start and end points
ctx.fillStyle = 'blue';
ctx.beginPath();
ctx.arc(start.x, start.y, 5, 0, 2 * Math.PI);  // Start point
ctx.arc(end.x, end.y, 5, 0, 2 * Math.PI);      // End point
ctx.fill();

// Control points
ctx.fillStyle = 'red';
ctx.beginPath();
ctx.arc(cp1.x, cp1.y, 5, 0, 2 * Math.PI);  // Control point one
ctx.arc(cp2.x, cp2.y, 5, 0, 2 * Math.PI);  // Control point two
ctx.fill();</pre>

<h4 id="Result">Result</h4>

<p>In this example, the <span style="color: red;">control points are red</span> and the <span style="color: blue;">start and end points are blue</span>.</p>

<p>{{ EmbedLiveSample('How_bezierCurveTo_works', 315, 165) }}</p>

<h3 id="A_simple_Bézier_curve">A simple Bézier curve</h3>

<p>This example draws a simple Bézier curve using <code>bezierCurveTo()</code>.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The curve begins at the point specified by <code>moveTo()</code>: (30, 30). The first control point is placed at (120, 160), and the second at (180, 10). The curve ends at (220, 140).</p>

<pre class="brush: js; highlight:[6]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.moveTo(30, 30);
ctx.bezierCurveTo(120,160, 180,10, 220,140);
ctx.stroke();</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('A_simple_Bézier_curve', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-beziercurveto", "CanvasRenderingContext2D.beziercurveto")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.bezierCurveTo")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li><a href="http://en.wikipedia.org/wiki/B%C3%A9zier_curve">Wikipedia article on Bézier curves</a></li>
</ul>
